blob: 14285b15a8a1a6b10c9146c554482c54588e140d [file] [log] [blame]
Masahiro Yamada0a9064f2014-07-30 14:08:13 +09001# ===========================================================================
2# Kernel configuration targets
3# These targets are used from top-level makefile
Tom Rinida58dec2015-11-10 01:06:16 +00004#
5# SPDX-License-Identifier: GPL-2.0
6#
Masahiro Yamada0a9064f2014-07-30 14:08:13 +09007
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +09008PHONY += xconfig gconfig menuconfig config silentoldconfig update-po-config \
Masahiro Yamada0a9064f2014-07-30 14:08:13 +09009 localmodconfig localyesconfig
10
Masahiro Yamada5f9eb222015-03-13 18:08:55 +090011# Added for U-Boot
12# Linux has defconfig files in arch/$(SRCARCH)/configs/,
13# on the other hand, U-Boot does in configs/.
14# Set SRCARCH to .. fake this Makefile.
15SRCARCH := ..
16
Masahiro Yamada0a9064f2014-07-30 14:08:13 +090017ifdef KBUILD_KCONFIG
18Kconfig := $(KBUILD_KCONFIG)
19else
20Kconfig := Kconfig
21endif
22
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +090023ifeq ($(quiet),silent_)
24silent := -s
25endif
26
Masahiro Yamada0a9064f2014-07-30 14:08:13 +090027# We need this, in case the user has it in its environment
28unexport CONFIG_
29
30xconfig: $(obj)/qconf
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +090031 $< $(silent) $(Kconfig)
Masahiro Yamada0a9064f2014-07-30 14:08:13 +090032
33gconfig: $(obj)/gconf
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +090034 $< $(silent) $(Kconfig)
Masahiro Yamada0a9064f2014-07-30 14:08:13 +090035
36menuconfig: $(obj)/mconf
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +090037 $< $(silent) $(Kconfig)
Masahiro Yamada0a9064f2014-07-30 14:08:13 +090038
39config: $(obj)/conf
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +090040 $< $(silent) --oldaskconfig $(Kconfig)
Masahiro Yamada0a9064f2014-07-30 14:08:13 +090041
42nconfig: $(obj)/nconf
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +090043 $< $(silent) $(Kconfig)
Masahiro Yamada0a9064f2014-07-30 14:08:13 +090044
45silentoldconfig: $(obj)/conf
46 $(Q)mkdir -p include/config include/generated
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +090047 $< $(silent) --$@ $(Kconfig)
Masahiro Yamada0a9064f2014-07-30 14:08:13 +090048
49localyesconfig localmodconfig: $(obj)/streamline_config.pl $(obj)/conf
50 $(Q)mkdir -p include/config include/generated
51 $(Q)perl $< --$@ $(srctree) $(Kconfig) > .tmp.config
52 $(Q)if [ -f .config ]; then \
53 cmp -s .tmp.config .config || \
54 (mv -f .config .config.old.1; \
55 mv -f .tmp.config .config; \
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +090056 $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
Masahiro Yamada0a9064f2014-07-30 14:08:13 +090057 mv -f .config.old.1 .config.old) \
58 else \
59 mv -f .tmp.config .config; \
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +090060 $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
Masahiro Yamada0a9064f2014-07-30 14:08:13 +090061 fi
62 $(Q)rm -f .tmp.config
63
64# Create new linux.pot file
65# Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
66update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +090067 $(Q)$(kecho) " GEN config.pot"
Masahiro Yamada0a9064f2014-07-30 14:08:13 +090068 $(Q)xgettext --default-domain=linux \
69 --add-comments --keyword=_ --keyword=N_ \
70 --from-code=UTF-8 \
71 --files-from=$(srctree)/scripts/kconfig/POTFILES.in \
72 --directory=$(srctree) --directory=$(objtree) \
73 --output $(obj)/config.pot
74 $(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
75 $(Q)(for i in `ls $(srctree)/arch/*/Kconfig \
76 $(srctree)/arch/*/um/Kconfig`; \
77 do \
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +090078 $(kecho) " GEN $$i"; \
Masahiro Yamada0a9064f2014-07-30 14:08:13 +090079 $(obj)/kxgettext $$i \
80 >> $(obj)/config.pot; \
81 done )
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +090082 $(Q)$(kecho) " GEN linux.pot"
Masahiro Yamada0a9064f2014-07-30 14:08:13 +090083 $(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
84 --output $(obj)/linux.pot
85 $(Q)rm -f $(obj)/config.pot
86
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +090087# These targets map 1:1 to the commandline options of 'conf'
88simple-targets := oldconfig allnoconfig allyesconfig allmodconfig \
89 alldefconfig randconfig listnewconfig olddefconfig
90PHONY += $(simple-targets)
Masahiro Yamada0a9064f2014-07-30 14:08:13 +090091
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +090092$(simple-targets): $(obj)/conf
93 $< $(silent) --$@ $(Kconfig)
Masahiro Yamada0a9064f2014-07-30 14:08:13 +090094
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +090095PHONY += oldnoconfig savedefconfig defconfig
Masahiro Yamada0a9064f2014-07-30 14:08:13 +090096
97# oldnoconfig is an alias of olddefconfig, because people already are dependent
98# on its behavior(sets new symbols to their default value but not 'n') with the
99# counter-intuitive name.
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +0900100oldnoconfig: olddefconfig
Masahiro Yamada0a9064f2014-07-30 14:08:13 +0900101
102savedefconfig: $(obj)/conf
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +0900103 $< $(silent) --$@=defconfig $(Kconfig)
Masahiro Yamada0a9064f2014-07-30 14:08:13 +0900104
105defconfig: $(obj)/conf
106ifeq ($(KBUILD_DEFCONFIG),)
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +0900107 $< $(silent) --defconfig $(Kconfig)
Masahiro Yamada0a9064f2014-07-30 14:08:13 +0900108else
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +0900109 @$(kecho) "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
110 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
Masahiro Yamada0a9064f2014-07-30 14:08:13 +0900111endif
112
113%_defconfig: $(obj)/conf
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +0900114 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
Masahiro Yamada0a9064f2014-07-30 14:08:13 +0900115
Masahiro Yamada5f9eb222015-03-13 18:08:55 +0900116# Added for U-Boot (backward compatibility)
117%_config: %_defconfig
118 @:
119
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +0900120configfiles=$(wildcard $(srctree)/kernel/configs/$@ $(srctree)/arch/$(SRCARCH)/configs/$@)
Masahiro Yamadaad618992014-10-30 11:06:12 +0900121
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +0900122%.config: $(obj)/conf
123 $(if $(call configfiles),, $(error No configuration exists for this target on this architecture))
124 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m .config $(configfiles)
125 +$(Q)yes "" | $(MAKE) -f $(srctree)/Makefile oldconfig
Masahiro Yamadaad618992014-10-30 11:06:12 +0900126
127PHONY += kvmconfig
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +0900128kvmconfig: kvm_guest.config
129 @:
Masahiro Yamadaad618992014-10-30 11:06:12 +0900130
131PHONY += tinyconfig
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +0900132tinyconfig:
133 $(Q)$(MAKE) -f $(srctree)/Makefile allnoconfig tiny.config
Masahiro Yamadaad618992014-10-30 11:06:12 +0900134
Masahiro Yamada0a9064f2014-07-30 14:08:13 +0900135# Help text used by make help
136help:
137 @echo ' config - Update current config utilising a line-oriented program'
138 @echo ' nconfig - Update current config utilising a ncurses menu based program'
139 @echo ' menuconfig - Update current config utilising a menu based program'
140 @echo ' xconfig - Update current config utilising a QT based front-end'
141 @echo ' gconfig - Update current config utilising a GTK based front-end'
142 @echo ' oldconfig - Update current config utilising a provided .config as base'
143 @echo ' localmodconfig - Update current config disabling modules not loaded'
144 @echo ' localyesconfig - Update current config converting local mods to core'
145 @echo ' silentoldconfig - Same as oldconfig, but quietly, additionally update deps'
146 @echo ' defconfig - New config with default from ARCH supplied defconfig'
147 @echo ' savedefconfig - Save current config as ./defconfig (minimal config)'
148 @echo ' allnoconfig - New config where all options are answered with no'
149 @echo ' allyesconfig - New config where all options are accepted with yes'
150 @echo ' allmodconfig - New config selecting modules when possible'
151 @echo ' alldefconfig - New config with all symbols set to default'
152 @echo ' randconfig - New config with random answer to all options'
153 @echo ' listnewconfig - List new options'
154 @echo ' olddefconfig - Same as silentoldconfig but sets new symbols to their default value'
Masahiro Yamadaad618992014-10-30 11:06:12 +0900155# @echo ' kvmconfig - Enable additional options for guest kernel support'
156# @echo ' tinyconfig - Configure the tiniest possible kernel'
Masahiro Yamada0a9064f2014-07-30 14:08:13 +0900157
158# lxdialog stuff
159check-lxdialog := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
160
161# Use recursively expanded variables so we do not call gcc unless
162# we really need to do so. (Do not call gcc as part of make mrproper)
163HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
164 -DLOCALE
165
166# ===========================================================================
167# Shared Makefile for the various kconfig executables:
168# conf: Used for defconfig, oldconfig and related targets
169# nconf: Used for the nconfig target.
170# Utilizes ncurses
171# mconf: Used for the menuconfig target
172# Utilizes the lxdialog package
173# qconf: Used for the xconfig target
174# Based on QT which needs to be installed to compile it
175# gconf: Used for the gconfig target
176# Based on GTK which needs to be installed to compile it
177# object files used by all kconfig flavours
178
179lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
180lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
181
182conf-objs := conf.o zconf.tab.o
183mconf-objs := mconf.o zconf.tab.o $(lxdialog)
184nconf-objs := nconf.o zconf.tab.o nconf.gui.o
185kxgettext-objs := kxgettext.o zconf.tab.o
186qconf-cxxobjs := qconf.o
187qconf-objs := zconf.tab.o
188gconf-objs := gconf.o zconf.tab.o
189
Masahiro Yamadacb6e7b02014-10-30 11:06:10 +0900190hostprogs-y := conf nconf mconf kxgettext qconf gconf
Masahiro Yamada0a9064f2014-07-30 14:08:13 +0900191
192clean-files := qconf.moc .tmp_qtcheck .tmp_gtkcheck
193clean-files += zconf.tab.c zconf.lex.c zconf.hash.c gconf.glade.h
Masahiro Yamada0a9064f2014-07-30 14:08:13 +0900194clean-files += config.pot linux.pot
195
196# Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
197PHONY += $(obj)/dochecklxdialog
198$(addprefix $(obj)/,$(lxdialog)): $(obj)/dochecklxdialog
199$(obj)/dochecklxdialog:
200 $(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
201
202always := dochecklxdialog
203
204# Add environment specific flags
205HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
206
207# generated files seem to need this to find local include files
208HOSTCFLAGS_zconf.lex.o := -I$(src)
209HOSTCFLAGS_zconf.tab.o := -I$(src)
210
211LEX_PREFIX_zconf := zconf
212YACC_PREFIX_zconf := zconf
213
214HOSTLOADLIBES_qconf = $(KC_QT_LIBS)
215HOSTCXXFLAGS_qconf.o = $(KC_QT_CFLAGS)
216
217HOSTLOADLIBES_gconf = `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
218HOSTCFLAGS_gconf.o = `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
219 -Wno-missing-prototypes
220
221HOSTLOADLIBES_mconf = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
222
223HOSTLOADLIBES_nconf = $(shell \
Masahiro Yamadaad618992014-10-30 11:06:12 +0900224 pkg-config --libs menuw panelw ncursesw 2>/dev/null \
225 || pkg-config --libs menu panel ncurses 2>/dev/null \
Masahiro Yamada0a9064f2014-07-30 14:08:13 +0900226 || echo "-lmenu -lpanel -lncurses" )
227$(obj)/qconf.o: $(obj)/.tmp_qtcheck
228
Masahiro Yamadacb6e7b02014-10-30 11:06:10 +0900229ifeq ($(MAKECMDGOALS),xconfig)
Masahiro Yamada0a9064f2014-07-30 14:08:13 +0900230$(obj)/.tmp_qtcheck: $(src)/Makefile
231-include $(obj)/.tmp_qtcheck
232
233# QT needs some extra effort...
234$(obj)/.tmp_qtcheck:
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +0900235 @set -e; $(kecho) " CHECK qt"; dir=""; pkg=""; \
Masahiro Yamada0a9064f2014-07-30 14:08:13 +0900236 if ! pkg-config --exists QtCore 2> /dev/null; then \
237 echo "* Unable to find the QT4 tool qmake. Trying to use QT3"; \
238 pkg-config --exists qt 2> /dev/null && pkg=qt; \
239 pkg-config --exists qt-mt 2> /dev/null && pkg=qt-mt; \
240 if [ -n "$$pkg" ]; then \
241 cflags="\$$(shell pkg-config $$pkg --cflags)"; \
242 libs="\$$(shell pkg-config $$pkg --libs)"; \
243 moc="\$$(shell pkg-config $$pkg --variable=prefix)/bin/moc"; \
244 dir="$$(pkg-config $$pkg --variable=prefix)"; \
245 else \
246 for d in $$QTDIR /usr/share/qt* /usr/lib/qt*; do \
247 if [ -f $$d/include/qconfig.h ]; then dir=$$d; break; fi; \
248 done; \
249 if [ -z "$$dir" ]; then \
250 echo >&2 "*"; \
251 echo >&2 "* Unable to find any QT installation. Please make sure that"; \
252 echo >&2 "* the QT4 or QT3 development package is correctly installed and"; \
253 echo >&2 "* either qmake can be found or install pkg-config or set"; \
254 echo >&2 "* the QTDIR environment variable to the correct location."; \
255 echo >&2 "*"; \
256 false; \
257 fi; \
258 libpath=$$dir/lib; lib=qt; osdir=""; \
259 $(HOSTCXX) -print-multi-os-directory > /dev/null 2>&1 && \
260 osdir=x$$($(HOSTCXX) -print-multi-os-directory); \
261 test -d $$libpath/$$osdir && libpath=$$libpath/$$osdir; \
262 test -f $$libpath/libqt-mt.so && lib=qt-mt; \
263 cflags="-I$$dir/include"; \
264 libs="-L$$libpath -Wl,-rpath,$$libpath -l$$lib"; \
265 moc="$$dir/bin/moc"; \
266 fi; \
267 if [ ! -x $$dir/bin/moc -a -x /usr/bin/moc ]; then \
268 echo "*"; \
269 echo "* Unable to find $$dir/bin/moc, using /usr/bin/moc instead."; \
270 echo "*"; \
271 moc="/usr/bin/moc"; \
272 fi; \
273 else \
274 cflags="\$$(shell pkg-config QtCore QtGui Qt3Support --cflags)"; \
275 libs="\$$(shell pkg-config QtCore QtGui Qt3Support --libs)"; \
276 moc="\$$(shell pkg-config QtCore --variable=moc_location)"; \
277 [ -n "$$moc" ] || moc="\$$(shell pkg-config QtCore --variable=prefix)/bin/moc"; \
278 fi; \
279 echo "KC_QT_CFLAGS=$$cflags" > $@; \
280 echo "KC_QT_LIBS=$$libs" >> $@; \
281 echo "KC_QT_MOC=$$moc" >> $@
282endif
283
284$(obj)/gconf.o: $(obj)/.tmp_gtkcheck
285
Masahiro Yamadacb6e7b02014-10-30 11:06:10 +0900286ifeq ($(MAKECMDGOALS),gconfig)
Masahiro Yamada0a9064f2014-07-30 14:08:13 +0900287-include $(obj)/.tmp_gtkcheck
288
289# GTK needs some extra effort, too...
290$(obj)/.tmp_gtkcheck:
291 @if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then \
292 if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then \
293 touch $@; \
294 else \
295 echo >&2 "*"; \
296 echo >&2 "* GTK+ is present but version >= 2.0.0 is required."; \
297 echo >&2 "*"; \
298 false; \
299 fi \
300 else \
301 echo >&2 "*"; \
302 echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; \
303 echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; \
304 echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; \
305 echo >&2 "*"; \
306 false; \
307 fi
308endif
309
310$(obj)/zconf.tab.o: $(obj)/zconf.lex.c $(obj)/zconf.hash.c
311
312$(obj)/qconf.o: $(obj)/qconf.moc
313
314quiet_cmd_moc = MOC $@
315 cmd_moc = $(KC_QT_MOC) -i $< -o $@
316
317$(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
318 $(call cmd,moc)
319
320# Extract gconf menu items for I18N support
321$(obj)/gconf.glade.h: $(obj)/gconf.glade
322 $(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
323 $(obj)/gconf.glade